<form class="{{cssClass}}" autocomplete="off">

    <!-- HEADER -->
    <header class="sheet-header">
        <h1 class="charname">
            <input name="name" type="text" value="{{actor.name}}" placeholder="{{localize "PF2E.CharacterNamePlaceholder"}}"/>
        </h1>

        <div class="editsheet">
            <label>{{localize "PF2E.EditNPCLabel"}}</label><input class="isNPCEditable" name="flags.pf2e.editNPC.value" type="checkbox" data-dtype="Boolean" {{checked flags.pf2e.editNPC.value}}/>
        </div>
        </h1>
        <h1 class="charlevel">
            <div class="level">
                <label>{{localize "PF2E.LevelLabel"}}</label>
                <input name="data.details.level.value" type="text" value="{{data.details.level.value}}"
                        data-dtype="Number" placeholder="1"/>
            </div>
            <div class="creature-adjustment traits-bar">
                <a class="npc-elite-adjustment trait{{npcEliteActive}}{{npcEliteHidden}}">ELITE</a>
                <a class="npc-weak-adjustment trait{{npcWeakActive}}{{npcWeakHidden}}">WEAK</a>
            </div>
        </h1>
    </header>

<!-- SIDEBAR -->
<section class="sheet-sidebar sidebar">

        <!-- ABILITY SCORES -->
        <div class="abilities" data-group="sidebar" data-tab="abilities">
            
            <h3 class="ac-title pf-heading">{{localize "PF2E.DefencesLabel"}}</h3>
            <ol class="npc-defence-list">
                <span class="armor-class" title="{{localize "PF2E.ArmorClassLabel"}}">
                    <input name="data.attributes.ac.base" type="text" value="{{data.attributes.ac.base}}"
                            data-dtype="Number" placeholder="10"/>
                </span>
                <span class="shield-value" title="{{localize "PF2E.ShieldACBonusTitle"}}">
                    <input name="data.attributes.shield.ac" type="text" value="{{data.attributes.shield.ac}}"
                            data-dtype="Number" placeholder="+0"/>
                </span> 
                <div class="hp-current pf-container">
                    <h4 class="hp-current pf-title">{{localize "PF2E.CurrentHitPointsShortLabel"}}</h4>
                    <span class="hp-current pf-value pf-large" title="{{localize "PF2E.CurrentHPTitle"}}">
                            <input name="data.attributes.hp.value" type="text" value="{{data.attributes.hp.value}}"
                                    data-dtype="Number" placeholder="10"/>
                        </span>
                    </div>
                    <div class="hp-max pf-container">
                        <h4 class="hp-max pf-title">{{localize "PF2E.MaxHitPointsShortLabel"}}</h4>
                        <span class="hp-max pf-value pf-large" title="{{localize "PF2E.MaxHPTitleNPC"}}">
                            <input name="data.attributes.hp.max" type="text" value="{{data.attributes.hp.max}}"
                                    data-dtype="Number" placeholder="10"/>
                        </span>
                    </div>
            </ol>
            <ol class="hp-list-small">
                <li class="li-four-grid">
                    <div class="defense-container pf-justify-center">
                        <h4 class="defense-item pf-title" title="{{localize "PF2E.ShieldCurrentTitle"}}">{{localize "PF2E.ShieldCurrentLabel"}}</h4>
                        <span class="defense-item-value pf-value pf-small" title="{{localize "PF2E.ShieldCurrentTitle"}}">
                            <input name="data.attributes.shield.value" type="text" value="{{data.attributes.shield.value}}"
                                    data-dtype="Number" placeholder="0"/>
                        </span>
                    </div>
                    <div class="defense-container pf-justify-center">
                        <h4 class="defense-item pf-title" title="{{localize "PF2E.ShieldMaxTitle"}}">{{localize "PF2E.ShieldMaxLabel"}}</h4>
                        <span class="defense-item-value pf-value pf-small" title="{{localize "PF2E.ShieldMaxTitle"}}">
                            <input name="data.attributes.shield.max" type="text" value="{{data.attributes.shield.max}}"
                                    data-dtype="String" placeholder="0"/>
                        </span>
                    </div>
                    <div class="defense-container pf-justify-center">
                        <h4 class="defense-item pf-title" title="Your shields Broken Threshold">{{localize "PF2E.ShieldBTLabel"}}</h4>
                        <span class="defense-item-value pf-value pf-small" title="{{localize "PF2E.ShieldBTTitle"}}">
                            <input name="data.attributes.shield.brokenThreshold" type="text" value="{{data.attributes.shield.brokenThreshold}}"
                                    data-dtype="String" placeholder="0"/>
                        </span>
                    </div>
                    <div class="defense-container pf-justify-center">
                        <h4 class="defense-item pf-title" title="{{localize "PF2E.ShieldHardnessTitle"}}">{{localize "PF2E.ShieldHardnessLabel"}}</h4>
                        <span class="defense-item-value pf-value pf-small" title="{{localize "PF2E.ShieldHardnessTitle"}}">
                            <input name="data.attributes.shield.hardness" type="text" value="{{data.attributes.shield.hardness}}"
                                    data-dtype="Number" placeholder="0"/>
                        </span>
                    </div>
                </li>
            </ol>
            <ol class="singleColumn-list" style="margin-bottom: 2px; margin-top: 2px;">
                <li>
                     <div class="bio-item form-group-stacked pf-container">
                        <label class="pf-title" for="data.traits.di">
                            {{localize "PF2E.ImmunitiesLabel"}}
                            <a class="trait-selector" data-options="immunityTypes"><i class="fas fa-edit"></i></a>
                        </label>
                        <ul class="traits-list pf-value">
                        {{#each data.traits.di.selected as |v k|}}
                            <span class="tag {{k}}">{{v}}</span>
                        {{/each}}
                        </ul>
                    </div>
                </li>
                <li>
                    <div class="form-group-stacked pf-container">
                        <label class="pf-title" for="data.traits.dr">
                            {{localize "PF2E.ResistancesLabel"}}
                            <a class="trait-selector" data-options="resistanceTypes" data-has-values="true" data-has-exceptions="true"><i class="fas fa-edit"></i></a>
                        </label>
                        <ul id="actor-resistances" class="traits-list pf-value">
                        {{#each data.traits.dr.selected as |v k|}}
                            <span class="tag {{k}}">{{v}}</span>
                        {{/each}}
                        </ul>
                    </div>
                </li>
                <li>
                    <div class="form-group-stacked pf-container">
                        <label class="pf-title" for="data.traits.dv">
                            {{localize "PF2E.WeaknessesLabel"}}
                            <a class="trait-selector" data-options="weaknessTypes" data-has-values="true"><i class="fas fa-edit"></i></a>
                        </label>
                        <ul id="actor-resistances" class="traits-list pf-value">
                        {{#each data.traits.dv.selected as |v k|}}
                            <span class="tag {{k}}">{{v}}</span>
                        {{/each}}
                        </ul>
                    </div>
                </li>
            </ol>
            <h3 class="defense-title pf-heading">{{localize "PF2E.PerceptionHeader"}}</h3>
            <ol class="defense-list">
                    
                    <li class="npc-defense" data-attribute="perception">
                        <span class="defense-score">
                        <input name="data.attributes.perception.base" type="text" value="{{data.attributes.perception.base}}"
                            data-dtype="Number" placeholder="0"/>
                        </span>
                        <h4 class="attribute-name rollable">{{localize "PF2E.PerceptionLabel"}}</h4>                             
                    </li>
                    <div class="npc-bio-item trait-size pf-container" style="width: calc(100% - 4px); margin-right: 3px;">
                        <label class="pf-title">{{localize "PF2E.SpecialSensesLabel"}}</label>
                        <span class="pf-value pf-small pf-width-100" title="{{localize "PF2E.SpecialSensesTitle"}}">
                            <input name="data.traits.senses.value" type="text" value="{{data.traits.senses.value}}"
                                data-dtype="String">
                        </span>
                    </div>
                
            </ol>


            <h3 class="defense-title pf-heading">{{localize "PF2E.SavesHeader"}}</h3>
            <ol class="defense-list">
                {{#each data.saves as |save sid|}}
                    <li class="npc-defense" data-save="{{sid}}" title="{{save.breakdown}}">
                        <span class="defense-score">
                                <input name="data.saves.{{sid}}.base" type="text" value="{{save.base}}"
                                data-dtype="Number" placeholder="0"/>
                        </span>
                        <h4 class="save-name rollable">{{save.label}}</h4>
                    </li>
                {{/each}}
            </ol>

            <h3 class="defense-title pf-heading">{{localize "PF2E.DetailsHeading"}}</h3>
                <ol class="singleColumn-list" style="margin-bottom: 2px; margin-top: 2px;">
                    <div class="bio-item form-group-stacked pf-container">
                        <label class="pf-title" for="data.traits.languages">
                            {{localize "PF2E.Languages"}}
                            <a class="trait-selector" data-options="languages"><i class="fas fa-edit"></i></a>
                        </label>
                        <ul class="traits-list pf-value">
                        {{#each data.traits.languages.selected as |v k|}}
                            <span class="tag {{k}}">{{v}}</span>
                        {{/each}}
                        </ul>
                    </div>
                    <div class="bio-item form-group-stacked pf-container">
                        <label class="pf-title" for="data.traits.traits">
                            {{localize "PF2E.TraitsLabel"}}
                            <a class="trait-selector" data-options="monsterTraits"><i class="fas fa-edit"></i></a>
                        </label>
                        <ul class="traits-list pf-value">
                        {{#each data.traits.traits.selected as |v k|}}
                            <span class="tag {{k}}">{{v}}</span>
                        {{/each}}
                        </ul>
                    </div>
            </ol>
            <ol class="bio-list">
                    <div class="bio-item trait-size pf-container">
                            <label class="pf-title">{{localize "PF2E.SizeLabel"}}</label>
                            <select class="pf-value pf-small pf-width-100" name="data.traits.size.value" data-dtype="String">
                                {{#select data.traits.size.value}}
                                {{#each actorSizes as |label size|}}
                                    <option value="{{size}}">{{label}}</option>
                                {{/each}}
                                {{/select}}
                            </select>
                    </div>
                    
                    <div class="npc-bio-item trait-size pf-container">
                        <label class="pf-title">{{localize "PF2E.Speed"}}</label>
                        <span class="pf-value pf-small pf-width-100" title="{{localize "PF2E.SpeedTitle"}}">
                            <input type="text" name="data.attributes.speed.value" data-dtype="String"
                                value="{{data.attributes.speed.value}}" placeholder="None"/>
                        </span>
                    </div>

                    <div class="bio-item trait-size pf-container">
                        <label class="pf-title">{{localize "PF2E.Alignment"}}</label>
                        <select class="pf-value pf-small pf-width-100" name="data.details.alignment.value" data-dtype="String">
                            {{#select data.details.alignment.value}}
                            {{#each alignment as |label key|}}
                                <option value="{{key}}">{{label}}</option>
                            {{/each}}
                            {{/select}}
                        </select>
                    </div>
                    <div class="bio-item trait-size pf-container">
                        <label class="pf-title">{{localize "PF2E.Rarity"}}</label>
                        <select class="pf-value pf-small pf-width-100" name="data.traits.rarity.value" data-dtype="String">
                            {{#select data.traits.rarity.value}}
                            {{#each rarity as |label key|}}
                            <option value="{{key}}">{{localize label}}</option>
                            {{/each}}
                            {{/select}}
                        </select>
                    </div>
                    <div class="bio-item trait-size pf-container">
                      <label class="pf-title">{{localize "PF2E.AttitudeLabel"}}</label>
                      <select class="pf-value pf-small pf-width-100" name="data.traits.attitude.value" data-dtype="String">
                        {{#select data.traits.attitude.value}}
                        {{#each attitude as |label key|}}
                          <option value="{{key}}">{{localize label}}</option>
                        {{/each}}
                        {{/select}}
                      </select>
                    </div>
                    <div class="bio-item trait-size pf-container">
                        <label class="pf-title">{{localize "PF2E.ImageLabel"}}</label>
                        <img class="sheet-profile" src="{{actor.img}}" title="{{actor.name}}" height="110" width="110" data-edit="img"/>
                    </div>
            </ol>
        </div>
    </section>

    <!-- BODY -->
    <section class="sheet-body content">

            <!-- Items List -->
            <ol class="actions-list inventory-list directory-list">
                <!-- Action Header -->
                <li class="item action-header">
                    <h3 class="item-name pf-heading pf-actions" style="display: block; padding-left: 44px">Actions</h3>
                    {{#if owner}}
                    <div class="item-controls">
                        <a class="item-control item-create pf-heading" title="{{localize "PF2E.CreateActionTitle"}}" data-type="action" data-action-type="action"><i class="fas fa-plus"></i>{{localize "PF2E.AddShortLabel"}}</a>
                    </div>
                    {{/if}}
                </li>
                
                <!-- List Actions -->
                {{#each actor.actions as |section sid|}}
                    {{#each section.actions as |action aid|}}
                    <li class="item" data-item-id="{{action._id}}">
                        <div class="item-name rollable">
                            <div class="item-image" style="background-image: url({{action.img}})"></div>
                            <h4>
                                {{action.name}}
                            </h4>
                        </div>
                        {{#if ../../owner}}
                        <div class="item-controls">
                            <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                            <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>                            
                        </div>
                        {{/if}}
                    </li>
                    {{/each}}
                {{/each}}

                <!-- Equipment Header -->
                <li class="item action-header item-container" data-container-type="actorInventory">
                    <h3 class="item-name pf-heading pf-actions" style="display: block; padding-left: 44px">Items</h3>
                    {{#if owner}}
                    <div class="item-controls">
                        <a class="item-control item-create pf-heading" title="{{localize "PF2E.CreateItemTitle"}}" data-type="equipment" data-action-type="equipment"><i class="fas fa-plus"></i>{{localize "PF2E.AddShortLabel"}}</a>
                    </div>
                    {{/if}}
                </li>
                <!-- List Equipment -->
                {{#each actor.equipment as |item iid|}}
                    
                    <li class="item item-container" data-container-type="actorInventory" data-item-id="{{item._id}}">
                        <div class="item-name rollable">
                            <div class="item-image" style="background-image: url({{item.img}})"></div>
                            <h4>
                                {{item.name}}
                            </h4>
                        </div>
                        {{#if ../owner}}
                        <div class="item-controls">
                            <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                            <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>                            
                        </div>
                        {{/if}}
                    </li>
                    
                {{/each}}

                <!-- Attacks Header -->
                <h3 class="item-name pf-heading pf-actions">Attacks</h3>

                <!-- List Attacks -->
                {{#each actor.attacks as |section sid|}}
                    <li class="item inventory-header sub-category spellbook-header">
                        <h3 class="item-name pf-sub-category pf-actions">{{section.label}}</h3>
                        {{#if ../owner}}
                        <div class="item-controls">
                            <a class="item-control item-create" title="{{localize "PF2E.CreateAttackTitle"}}" data-type="{{section.type}}" data-action-type="{{sid}}"><i class="fas fa-plus"></i>{{localize "PF2E.AddShortLabel"}}</a>
                        </div>
                        {{/if}}
                    </li>
                    {{#each section.items as |item iid|}}
                    <li class="item" data-item-id="{{item._id}}">
                        <div class="melee-name rollable">
                            <div class="item-image" style="background-image: url({{item.img}})"></div>
                            <h4>
                                {{item.name}}
                            </h4>
                            <div class="melee-buttons">
                                <span class="tag"><button type="button" data-action="npcAttack" >Strike (+{{item.data.bonus.total}})</button></span>
                                <span class="tag"><button type="button" data-action="npcAttack2" >{{#unless item.data.isAgile}}-5{{else}}-4{{/unless}}</button></span>
                                <span class="tag"><button type="button" data-action="npcAttack3" >{{#unless item.data.isAgile}}-10{{else}}-8{{/unless}}</button></span>
                                <span class="tag"><button type="button" data-action="npcDamage">Damage
                                    {{#if item.data.damageRolls}}
                                        {{#each item.data.damageRolls as |dmg index|}}
                                            {{dmg.damage}} {{dmg.damageType}}
                                        {{/each}}
                                    {{/if}}
                                </button></span>
                                <span class="tag"><button type="button" data-action="npcDamageCritical">{{localize "PF2E.CriticalDamageLabel"}}</button></span>
                            </div>
                        </div>
                        {{#if ../../owner}}
                        <div class="item-controls">
                            <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                            {{#unless action.feat}}
                            <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
                            {{/unless}}
                        </div>
                        {{/if}}
                    </li>
                    {{/each}}
                {{/each}}


                    {{#each actor.spellcastingEntries as |entry eid|}}
                        <li class="item action-header item-container" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                            <!-- <div class="action-header"> -->
                                {{#if entry.data.prepared.preparedSpells}}
                                <a class="skill-name prepared-toggle" title="{{localize "PF2E.ToggleSpellVisibilityTitle"}}" style="line-height: 24px; background: var(--primary-background); color: white;"><i class="fab fa-stack-overflow"></i></a>
                                {{/if}}
                                <h3 class="item-name pf-heading pf-actions" style="display: block; flex: 20;">{{{entry.name}}}</h3>
                                {{#if ../owner}}
                                <div class="item-controls" style="display: flex; background: var(--primary-background);">
                                    <a class="item-control spellcasting-remove" title="{{localize "PF2E.RemoveSpellcastingEntryTitle"}}" data-type="{{eid}}" style="align-self: center; flex: 1;  color: white;"><i class="fas fa-minus"></i>{{localize "PF2E.DeleteShortLabel"}}</a>
                                </div>
                                {{/if}}
                        </li>
                        <li class="item action-header item-container" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                            <!-- </div> -->
                            <ol class="npc-defense-list" style="grid: 'dc attack' 40px;">
                                <li class="npc-defense" data-spelldc-attribute="dc">
            
                                    <span class="defense-score spelldc-input">
                                        <input name="data.items.{{eid}}.data.spelldc.dc" type="text" value="{{entry.data.spelldc.dc}}"
                                                data-dtype="Number" placeholder="0"/>
                                    </span>
                                    <h4 class="spelldc-name">{{localize "PF2E.SpellSaveLabel"}}</h4>
                                </li>
                                <li class="npc-defense" data-spelldc-attribute="value">
                                        <span class="defense-score spelldc-input">
                                            <input name="data.items.{{eid}}.data.spelldc.value" type="text" value="{{entry.data.spelldc.value}}"
                                                    data-dtype="Number" placeholder="0"/>
                                        </span>
                                        <h4 class="spelldc-name">{{localize "PF2E.SpellAttackLabel"}}</h4>
                                </li>
                            </ol>
                        </li>
                        <li class="item action-header item-container" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">

                            {{#unless entry.data.prepared.preparedSpells}}

                            <!-- Everything except prepared spells -->
            
                                    <!-- Add section for each spell level -->
                                    {{#each entry.spellbook as |section lvl|}}
                                        <li class="item inventory-header spellbook-header item-container" style="background: var(--secondary-background);" data-item-id="{{entry._id}}" data-level="{{lvl}}" 
                                            data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                            <div class="item-name flexrow">
                                                <h3>{{section.label}}</h3>
                                
                                                {{#unless entry.data.tradition.ritual}}
                                                    {{#unless section.isCantrip}}
                                                    <span class="spell-slots-input">
                                                        <input type="text" name="data.items.{{eid}}.data.slots.slot{{lvl}}.value" value="{{section.uses}}" placeholder="0"/>
                                                    </span>
                                                    <span class="flex0"> / </span>
                                                    <span class="spell-max-input">
                                                        <input type="text" name="data.items.{{eid}}.data.slots.slot{{lvl}}.max" value="{{section.slots}}" placeholder="0"/>
                                                    </span>
                                                    {{else}}
                                                    <span class="spell-slots">&infin;</span>
                                                    <span class="flex0"> / </span>
                                                    <span class="spell-max">&infin;</span>
                                                    {{/unless}}
                                                {{/unless}}
                                            </div>
                                
                                
                                            {{#if ../../owner}}
                                            <div class="item-controls">
                                                <a class="item-control spell-create" title="{{localize "PF2E.CreateSpellTitle"}}" data-type="spell"
                                                    data-level="{{lvl}}" data-location="{{entry._id}}"><i class="fas fa-plus"></i></a>
                                                <a class="item-control spell-browse" title="{{localize "PF2E.OpenSpellBrowserTitle"}}" data-type="spell"
                                                    data-level="{{lvl}}" data-location="{{entry._id}}"><i class="fas fa-search"></i></a>
                                            </div>
                                            {{/if}}
                                        </li>
                                
                                        <!-- Add spell items for each spell level -->
                                        {{#each section.spells as |item i|}}
                                        <li class="item item-container" data-item-id="{{item._id}}" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                            <div class="item-name rollable">
                                                <div class="item-image" style="background-image: url({{item.img}})"></div>
                                                <h4>{{item.name}}</h4>
                                            </div>
                                
                                
                                            {{#if ../../../owner}}
                                            <div class="item-controls">
                                                <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                                                <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
                                            </div>
                                            {{/if}}
                                        </li>
                                        {{/each}}
                                    {{else}}
                                        <!-- Add Spells Row -->
                                        <li class="item inventory-header spellbook-header spellbook-empty item-container" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                            {{#if ../owner}}
                                            <div class="item-controls pf-bluelist pf-add-item-row" style="display: flex; flex: 1; background: var(--secondary-background);">
                                                <a class="item-control spell-create" title="{{localize "PF2E.CreateSpellTitle"}}" data-type="spell"
                                                    data-level="{{lvl}}" data-location="{{entry._id}}" style="flex: 1;"><i class="fas fa-plus"></i>{{localize "PF2E.AddSpellTitle"}}</a>
                                                <a class="item-control spell-browse" title="{{localize "PF2E.OpenSpellBrowserTitle"}}" data-type="spell"
                                                    data-level="{{lvl}}" data-location="{{entry._id}}" style="flex: 1;"><i class="fas fa-search"></i>{{localize "PF2E.OpenSpellBrowserTitle"}}</a>
                                            </div>
                                            {{/if}}
                                        </li>
                                    {{/each}}
                                <!-- </ol> -->
                        {{else}}
                        
                            <!-- Prepared Spells -->
            
                                <!-- Add section for each level -->
                                {{#each entry.spellbook as |section lvl|}}
                                    <li class="item inventory-header spellbook-header item-container" style="background: var(--secondary-background);" data-item-id="{{entry._id}}" data-level="{{lvl}}" 
                                        data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                        <div class="item-name flexrow">
                                            <h3>{{section.label}}</h3>
                            
                                            {{#if section.isFocus}}
                                            <span class="spell-slots-input">
                                                <input type="text" name="data.items.{{eid}}.data.slots.slot{{lvl}}.value" value="{{section.uses}}" placeholder="0"/>
                                            </span>
                                            <span class="flex0"> / </span>
                                            <span class="spell-max-input">
                                                <input type="text" name="data.items.{{eid}}.data.slots.slot{{lvl}}.max" value="{{section.slots}}" placeholder="0"/>
                                            </span>
                                            {{else}}
                                            <span class="spell-max-input">
                                                <input type="text" name="data.items.{{eid}}.data.slots.slot{{lvl}}.max" value="{{section.slots}}" placeholder="0"/>
                                            </span>
                                            {{/if}}
                                        </div>
                            
                            
                                        {{#if ../../owner}}
                                        <div class="item-controls">
                                            <a class="item-control spell-create" title="{{localize "PF2E.CreateSpellTitle"}}" data-type="spell"
                                                data-level="{{lvl}}" data-location="{{entry._id}}"><i class="fas fa-plus"></i></a>
                                            <a class="item-control spell-browse" title="{{localize "PF2E.OpenSpellBrowserTitle"}}" data-type="spell"
                                                data-level="{{lvl}}" data-location="{{entry._id}}"><i class="fas fa-search"></i></a>
                                        </div>
                                        {{/if}}
                                    </li>
                            
                                    {{#unless section.isFocus}}
                                        {{#each section.prepared as |item i|}}
                                        
                                            {{#if item.prepared}}
                                                <li class="item item-container" data-item-id="{{item._id}}" data-slot-id="{{i}}" data-spell-lvl="{{lvl}}" data-entry-id="{{entry._id}}" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                                    <div class="item-name">
                                                        <div class="item-image" style="background-image: url({{item.img}})"></div>
                                                        <h4>{{item.name}}</h4>
                                                    </div>
                            
                                    
                                                    {{#if ../../../owner}}
                                                    <div class="item-controls">
                                                        <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                                                        <a class="item-control item-unprepare" title="{{localize "PF2E.UnprepareItemTitle"}}"><i class="fas fa-minus-square"></i></a>
                                                    </div>
                                                    {{/if}}
                                                </li>
                                            {{else}}
                                                <li class="item item-container" data-item-id="{{i}}" data-spell-lvl="{{lvl}}" data-item-type="spellSlot" data-entry-id="{{entry._id}}" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                                    <div class="item-name" style="padding-left:30px;">
                                                        <h4>{{item.name}}</h4>
                                                    </div>
                                                </li>
                                            {{/if}}
                                        
                                        {{/each}}
                                        
                                        {{#if entry.data.showUnpreparedSpells.value}}
                                        <h3 class="item-name pf-sub-category pf-actions" style="background: var(--tertiary-background);">{{localize "PF2E.UnpreparedSpellsLabel"}}</h3>
                                                
                                        <!-- Unprepared Spells -->
                                            {{#each section.spells as |item i|}}
                                                <li class="item" data-item-id="{{item._id}}">
                                                    <div class="item-name rollable">
                                                        <div class="item-image" style="background-image: url({{item.img}})"></div>
                                                        <h4>{{item.name}}</h4>
                                                    </div>
                            
                            
                                                    {{#if ../../../owner}}
                                                    <div class="item-controls">
                                                        <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                                                        <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
                                                    </div>
                                                    {{/if}}
                                                </li>
                                            {{/each}}
                                        {{/if}}
                                    {{else}}
                                        <!-- Add spell items for each level -->
                                        {{#each section.spells as |item i|}}
                                        <li class="item" data-item-id="{{item._id}}">
                                            <div class="item-name rollable">
                                                <div class="item-image" style="background-image: url({{item.img}})"></div>
                                                <h4>{{item.name}}</h4>
                                            </div>
                            
                            
                                            {{#if ../../../owner}}
                                            <div class="item-controls">
                                                <a class="item-control item-edit" title="{{localize "PF2E.EditItemTitle"}}"><i class="fas fa-edit"></i></a>
                                                <a class="item-control item-delete" title="{{localize "PF2E.DeleteItemTitle"}}"><i class="fas fa-trash"></i></a>
                                            </div>
                                            {{/if}}
                                        </li>
                                        {{/each}}
                                    {{/unless}}
                
                                {{else}}
                                <!-- Add spells row -->
                                <li class="item inventory-header spellbook-header spellbook-empty item-container" data-container-type="spellcastingEntry" data-container-id="{{entry._id}}">
                                    {{#if ../owner}}
                                    <div class="item-controls pf-bluelist pf-add-item-row" style="display: flex; flex: 1; background: var(--secondary-background);">
                                        <a class="item-control spell-create" title="{{localize "PF2E.CreateSpellTitle"}}" data-type="spell"
                                            data-level="{{lvl}}" data-location="{{entry._id}}" style="flex: 1;"><i class="fas fa-plus"></i>{{localize "PF2E.AddSpellTitle"}}</a>
                                        <a class="item-control spell-browse" title="{{localize "PF2E.OpenSpellBrowserTitle"}}" data-type="spell"
                                            data-level="{{lvl}}" data-location="{{entry._id}}" style="flex: 1;"><i class="fas fa-search"></i>{{localize "PF2E.OpenSpellBrowserTitle"}}</a>
                                    </div>
                                    {{/if}}
                                </li>
                            {{/each}}
                        <!-- </ol> -->


                        {{/unless}}



















                        </li>

                    <!-- for each actor.spellcastingEntry -->
                    {{/each}}
                <!-- </ol> -->
                
                <li class="item action-header" style="display: flex;">
                    {{#if owner}}
                    <div class="item-controls pf-bluelist pf-add-item-row" style="display: flex; flex: 1;">
                        <a class="item-control spellcasting-create" title="{{localize "PF2E.CreateSpellTitle"}}" data-type="spell"
                            data-level="{{lvl}}" style="flex: 1; color: white;"><i class="fas fa-plus"></i>{{localize "PF2E.AddSpellcastingEntryTitle"}}</a>
                    </div>
                    {{/if}}
                </li>
                
                <!-- Skill Header -->
                <li class="item action-header">
                    <h3 class="item-name pf-heading pf-actions" style="display: block; padding-left: 44px">{{localize "PF2E.SkillsLabel"}}</h3>
                    {{#if owner}}
                    <div class="item-controls">
                        <a class="item-control item-create pf-heading" title="{{localize "PF2E.CreateSkillTitle"}}" data-type="lore"><i class="fas fa-plus"></i>{{localize "PF2E.AddShortLabel"}}</a>
                    </div>
                    {{/if}}
                </li>

                <!-- Skill List -->
                {{#each actor.lores as |lore lid|}}
                    <li class="item" data-skill="{{s}}" data-item-id="{{lore._id}}">

                        <div style="display: grid; grid: 24px / 28px 28px auto">

                            <div class="npc-skill-name rollable">
                                <img class="npc-skill-image" src="{{lore.img}}" title="{{lore.name}}" height="24" width="24" style="border: none" />
                                <!-- Roll -->
                            </div>
                            
                            <div class="skill-input">
                                <input name="item-value-skill-{{lore._id}}" data-item-id="{{lore._id}}" type="text" data-dtype="Number" value="{{lore.data.mod.value}}" placeholder="0"/>
                            </div>
                            
                            <div class="item-name item-name-input">
                                <input name="item-name-skill-{{lore._id}}" data-item-id="{{lore._id}}" type="text" data-dtype="String" value="{{lore.name}}" placeholder="{{localize "PF2E.NewSkillPlaceholder"}}"/>
                            </div>
                        </div>
                                                
                        {{#if ../owner}}
                        <div class="item-controls" style="padding-left: 22px">
                            <a class="item-control item-edit" title="{{localize 'PF2E.EditItemTitle'}}"><i class="fas fa-edit"></i></a>
                            <a class="item-control item-delete" title="{{localize 'PF2E.DeleteItemTitle'}}"><i class="fas fa-trash"></i></a>
                        </div>
                        {{/if}}
                    </li>
                {{/each}}

            </ol>

            <!-- ability scores -->
            <div class="npc-abilities">
                <h3 class="abilities-title pf-heading">{{localize "PF2E.AbilityScoresHeader"}}</h3>
                <ol class="abilities-list">
                    {{#each data.abilities as |ability id|}}
                            <li class="npc-defense" data-ability="{{id}}">
                                <span class="defense-score">
                                <input name="data.abilities.{{id}}.mod" type="text" value="{{numberFormat ability.mod decimals=0 sign=true}}"
                                    data-dtype="Number" placeholder="+0"/>
                                </span>
                                <h4 class="ability-name rollable">{{id}}</h4>
                            </li>
                        </li>
                    {{/each}}
                </ol>
            </div>
        
    </section>

</form>
